package sk.upjs.ics;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.LinkedList;
import java.util.List;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class RozvrhContentHandler extends DefaultHandler {
	private List<RozvrhovaAkcia> akcie = new LinkedList<RozvrhovaAkcia>();
	private RozvrhovaAkcia rozvrhovaAkcia;

	private StringBuilder buffer = new StringBuilder();
	
	private DateFormat format = new SimpleDateFormat("HH:mm");
	
	@Override
	public void startElement(String uri, String localName, String qName,
			Attributes attributes) throws SAXException {
		System.out.println(localName);
		if("prednaska".equals(localName)) {
			rozvrhovaAkcia = new RozvrhovaAkcia();
			rozvrhovaAkcia.setTyp(Type.PREDNASKA);
		}
		if("cvicenie".equals(localName)) {
			rozvrhovaAkcia = new RozvrhovaAkcia();
			rozvrhovaAkcia.setTyp(Type.CVICENIE);			
		}
	}
	
	@Override
	public void characters(char[] ch, int start, int length)
			throws SAXException {
		buffer.append(ch, start, length);
	}
	
	@Override
	public void endElement(String uri, String localName, String qName)
			throws SAXException {
		if("den".equals(localName)) {
			rozvrhovaAkcia.setDen(Day.valueOf(buffer.toString().toUpperCase()));
			buffer.setLength(0);
		}
		if("casOd".equals(localName)) {
			try {
				rozvrhovaAkcia.setCasOd(format.parse(buffer.toString()));
			} catch (ParseException e) {
				throw new SAXException("Nespravny format casu: " + buffer.toString(), e);
			}
			buffer.setLength(0);
		}
		if("prednaska".equals(localName) || "cvicenie".equals(localName)) {
			akcie.add(rozvrhovaAkcia);
			rozvrhovaAkcia = null;
		}
	}
	
	public List<RozvrhovaAkcia> getAkcie() {
		return akcie;
	}
}
