package sk.upjs.ics;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;

public class RozvrhParser {
	public List<RozvrhovaAkcia> parse(InputStream in) throws RozvrhParseException {
		try {
			SAXParserFactory saxParserFactory = SAXParserFactory.newInstance();
			SAXParser parser = saxParserFactory.newSAXParser();
			
			RozvrhContentHandler rozvrhContentHandler = new RozvrhContentHandler();
			parser.parse(in, rozvrhContentHandler);
			
			return rozvrhContentHandler.getAkcie();
			
		} catch (ParserConfigurationException e) {
			throw new RozvrhParseException(e);
		} catch (SAXException e) {
			throw new RozvrhParseException(e);
		} catch (FactoryConfigurationError e) {
			throw new RozvrhParseException(e);
		} catch (IOException e) {
			throw new RozvrhParseException(e);
		}
	}
	
	public static void main(String[] args) throws FileNotFoundException, RozvrhParseException {
		RozvrhParser rozvrhParser = new RozvrhParser();
		List<RozvrhovaAkcia> akcie = rozvrhParser.parse(new FileInputStream("rozvrh.xml"));
		for (RozvrhovaAkcia rozvrhovaAkcia : akcie) {
			System.out.println(rozvrhovaAkcia);
		}
	}
}
